# RadioLib: LoRaWANEvent_t Struct Reference

LoRaWANEvent_t Struct Reference

Structure to save extra information about uplink/downlink event. More...

`#include <LoRaWAN.h>`

## Public Attributes

uint8_t | dir
| Event direction, one of RADIOLIB_LORAWAN_CHANNEL_DIR_*.
bool | confirmed
| Whether the event is confirmed or not (e.g., confirmed uplink sent by user application)
bool | confirming
| Whether the event is confirming a previous request (e.g., server downlink reply to confirmed uplink sent by user application)
uint8_t | datarate
| Datarate.
float | freq
| Frequency in MHz.
int16_t | power
| Transmit power in dBm for uplink, or RSSI for downlink.
uint32_t | fCnt
| The appropriate frame counter - for different events, different frame counters will be reported!
uint8_t | fPort
| Port number.
uint8_t | nbTrans
| Number of times this uplink was transmitted (ADR)

## Detailed Description

Structure to save extra information about uplink/downlink event.

The documentation for this struct was generated from the following file:

- src/protocols/LoRaWAN/LoRaWAN.h